unit hiListBox;

interface

{$I share.inc}

uses Kol,Share,WinList,WIndows,Messages;

type
  THIListBox = class(THIWinList)
   private
    //function _Drag( Sender: PControl; ScrX, ScrY: Integer; var CursorShape: Integer;
    //        var Stop: Boolean ): Boolean;
    Arr:PArray;
    ValArr:PArray;
    procedure _OnClick(Obj:PObj);
    function _onDraw( Sender: PObj; DC: HDC; const Rect: TRect; ItemIdx: Integer;
                           DrawAction: TDrawAction; ItemState: TDrawState ): Boolean;
    procedure _arr_set(var Item:TData; var Val:TData);
     function _arr_get(Var Item:TData; var Val:TData):boolean;
     function _arr_count:integer;
    procedure _val_arr_set(var Item:TData; var Val:TData);
     function _val_arr_get(Var Item:TData; var Val:TData):boolean;
     function _val_arr_count:integer;

   public
    _prop_AddType:byte;
    _prop_SelectAdd:boolean;
    _prop_DataType:byte;
    _prop_Strings:string;
    _prop_Sort:boolean;
    _prop_MultiSelect:boolean;
    _prop_DefaultAVal:dword;
    _data_Value:THI_Event;
    _event_onClick:THI_Event;

    constructor Create(Parent:PControl);
    procedure Init; override;
    procedure _work_doAdd(var _Data:TData; Index:word);
    procedure _work_doSelect(var _Data:TData; Index:word);
    procedure _work_doSelectAll(var _Data:TData; Index:word);
    procedure _work_doSelectString(var _Data:TData; Index:word);
    procedure _work_doEnsureVisible(var _Data:TData; Index:word);
    procedure _var_Index(var _Data:TData; Index:word);
    procedure _var_SelectArray(var _Data:TData; Index:word);
    procedure _var_ValueArray(var _Data:TData; Index:word);
  end;

implementation

constructor THIListBox.Create;
begin
   inherited Create(Parent);
end;

procedure THIListBox.Init;
var Fl:TListOptions;
begin
   fl := [loNoIntegralHeight,loNoExtendSel{,loOwnerDrawFixed}];
   if _prop_Sort then
    Include(Fl,loSort);
   if _prop_MultiSelect then
    Include(Fl,loMultiSelect);
   Control := NewListbox(FParent,fl);
   Control.OnSelChange := _OnClick;
   Control.OnDrawItem := _onDraw;

   inherited;
   SetStrings(_prop_Strings);
   SendMessage(Control.GetWindowHandle,LB_SETHORIZONTALEXTENT, 200, 0);
   //ShowScrollBar(Control.GetWindowHandle,SB_HORZ,true);
end;

function THIListBox._onDraw;
var s:string;
begin
   Control.Canvas.Handle := Dc;
   with Control.Canvas{$ifndef F_P}^{$endif} do
    begin
     Brush.BrushStyle := bsSolid;
     if ItemState = [odsSelected] then
      begin
       Brush.Color := clBtnShadow;
       FillRect(Rect);
      end
     else if ItemState = [odsFocused] then
        DrawFocusRect(Rect)
     else if ItemState = [odsGrayed] then
      begin  //debug('ok');
       Brush.Color := clWindow;
       FillRect(Rect);
      end;

      Brush.BrushStyle := bsClear;
      s := Control.Items[ItemIdx]; // debug('ok');
      {if pos(':)',s) > 0 then
       begin

        Result := true;
       end
      else} TextOut(Rect.Left + 2,Rect.Top,s);
    end;

   Result := false;
end;
{
function  THIListBox._Drag;
begin
    Result := true;
    Stop := false;
end;
}

procedure THIListBox._work_doAdd;
var s:string;
    d:PData;
    dt,di:TData;
    idx:integer;
begin
   d:= @_Data;
TRY
   _ReadData(dt, _data_str);
   if (s = '') and (d <> nil) and not _IsNULL(d^) then begin //     
      s:= ToString(d^);
      d := d.ldata;
   end
   else s:= ToString(dt);

   if _prop_AddType = 0 then begin
      idx := Add(s);
      if _prop_SelectAdd then Control.CurIndex := idx;
      dtInteger(di, idx);
   end
   else begin
      idx := Control.Insert(0,s); 
      if idx = -1 then Control.Text := s + #13#10 + Control.Text;
      if _prop_SelectAdd then Control.CurIndex := idx;
      dtInteger(di, idx);
   end;

   dtNull(dt);
   _ReadData(dt, _data_value);
   if (ToInteger(dt) = 0) and (d <> nil) and not _IsNULL(d^) then begin
      dt:= d^;
      d := d.ldata;
   end;
   if _isNull(dt) then dtInteger(dt,_prop_DefaultAVal);
   _val_arr_set(di, dt);
   _hi_OnEvent(_event_onChange);

FINALLY
   dtNull(_Data);
   if (d <> nil) and not _IsNULL(d^) then FreeData(d); //    d
END;
end;

procedure THIListBox._work_doSelectAll;
var action, ind:integer;
begin
  action := ord(ToInteger(_Data)>=0);
  if (_prop_MultiSelect) then
    Control.Perform(LB_SETSEL,action,-1);
  for ind := 0 to Control.Count-1 do
    Control.ItemSelected[ind] := (ToInteger(_Data)>=0);
end;

procedure THIListBox._work_doSelect;
var ind:integer;
begin
  ind := ToInteger(_Data);
  if(ind >= 0)and(ind < Control.Count)then begin
    if  _prop_MultiSelect then begin
      Control.ItemSelected[ind] := not Control.ItemSelected[ind];//true;
      Control.Perform(LB_SETSEL,ord(Control.ItemSelected[ind]),ind);
    end else begin
      Control.CurIndex := ind;
      Control.Perform(LB_SETCURSEL,ind,0);
    end;
  end else begin
      if not (_prop_MultiSelect) then begin
        Control.Perform(LB_SETCURSEL,-1,0);
        Control.CurIndex := -1;
      end;
  end;
end;

procedure THIListBox._work_doSelectString;
var i:integer; s: string;
begin
  if _prop_MultiSelect then
    begin
      s := ToString(_Data);
      //i := Control.IndexOf(s);
      i := Control.Perform(LB_FINDSTRING,-1,integer(PChar(ToString(_Data))));
      dtInteger(_Data, i);
      _work_DoSelect(_Data, 0);
    end
  else  
    Control.Perform(LB_SELECTSTRING,-1,integer(PChar(ToString(_Data))));
end;

procedure THIListBox._work_doEnsureVisible;
begin
   Control.Perform(LB_SETTOPINDEX, ToInteger(_Data), 0);
end;

procedure THIListBox._var_Index;
begin
   dtInteger(_Data,Control.CurIndex);
end;

procedure THIListBox._OnClick;
var   d:PData;
      Data,dt,di:TData;
begin
   dtNull(Data);
   if _prop_DataType = 1 then
     dtString(dt,Control.Items[Control.CurIndex])
   else  dtInteger(dt,Control.CurIndex);
   AddMTData(@Data,@dt,d);
   dtInteger(di,Control.CurIndex);
   _val_arr_get(di,dt);
   AddMTData(@Data,@dt,d);      
   _hi_OnEvent(_event_onClick,Data);
   if (d <> nil) and not _IsNULL(d^) then FreeData(d); //    d
end;

procedure THIListBox._arr_set;
var ind:integer;
begin
   ind := ToIntIndex(Item);
   if(ind >=0 )and(ind < Control.Count)then
    Control.ItemSelected[ind] := ReadBool(Val);
end;

function THIListBox._arr_get;
var ind:integer;
begin
   ind := ToIntIndex(Item);
   Result := (ind >=0 )and(ind < Control.Count);
   if Result then
     dtInteger(Val,byte(Control.ItemSelected[ind]));
end;

function THIListBox._arr_count;
var i:smallint;
begin
   Result := 0;
   for i := 0 to Control.Count-1 do
    if Control.ItemSelected[i] then
      inc(Result);
end;

procedure THIListBox._val_arr_set;
var ind:integer;
begin
   ind := ToIntIndex(Item);
   if(ind >=0 )and(ind < Control.Count)then
    Control.Perform(LB_SETITEMDATA, ind, ReadInteger(Val, NULL, 0));
end;

function THIListBox._val_arr_get;
var ind:integer;
begin
   ind := ToIntIndex(Item);
   Result := (ind >=0 )and(ind < Control.Count);
   if Result then
     dtInteger(Val,integer(Control.Perform(LB_GETITEMDATA, ind, 0)));
end;

function THIListBox._val_arr_count;
begin
   Result := Control.Count;
end;

procedure THIListBox._var_SelectArray;
begin
  if Arr = nil then
    Arr := CreateArray(_arr_set,_arr_get,_arr_count,nil);
  dtArray(_Data,Arr);
end;

procedure THIListBox._var_ValueArray;
begin
  if ValArr = nil then
    ValArr := CreateArray(_val_arr_set,_val_arr_get,_val_arr_count,nil);
  dtArray(_Data,ValArr);
end;

end.
